/*
 *  rangeTester.cpp
 *  SimpleCacheSim
 *
 *  Created by Wade Tregaskis on 7/9/2005.
 *  Copyright 2005 Wade Tregaskis. All rights reserved.
 *
 */

#include "../range.h"
using namespace std;


typedef struct _Op {
    bool insert;
    int value;
} Op;


int main(int argc, char* const argv[]) {
    range<int> subject;
    range<int>::iterator iter, stopper;
    Op values[] = { {true, 5},
                    {true, 8},
                    {true, 4},
                    {true, 9},
                    {true, 6},
                    {true, 7},
                    {true, 1},
                    {true, 2},
                    {true, 3},
                    {false, 5},
                    {false, 9},
                    {false, 1},
                    {false, 6},
                    {false, 4},
                    {false, 3},
                    {false, 2},
                    {false, 7},
                    {false, 8} };
    unsigned int i;

    cout << "Initially: " << subject << endl;
    
    for (i = 0; i < (sizeof(values) / sizeof(Op)); ++i) {
        if (values[i].insert) {
            subject.insert(values[i].value);
            cout << "After inserting " << values[i].value << ": " << subject << endl;
        } else {
            subject.remove(values[i].value);
            cout << "After removing " << values[i].value << ": " << subject << endl;
        }
        
        cout << "\tManual iteration:";
        
        for (iter = subject.begin(), stopper = subject.end(); iter != stopper; ++iter) {
            cout << ' ' << *iter;
        }
        
        cout << endl;
    }
    
    return 0;
}
